# Name :
# Date : 25 May 2023
# Description : Game File which initializes all the area and path of the 
#               adventurous journey and interacts with player for the choices
#               he can make along his jorney and prints all information about
#               player and the current area he is.
    

from Player import Player
from Area import Area
from DeadlyArea import DeadlyArea
from Area import Path

class Game:
        
    def __init__(self):
        self.init()
        self.player = Player()
        
    def init(self):
        
        area1 = Area()
        area1.description = 'The sound of the rustling leaves is calling you to ' 
        area1.description += 'explore the densest of all the jungles. Don\'t get lost! '
        area1.description += 'The faint rays of sunlight filtering through the leaves '
        area1.description += 'pronounce vividly that, yes, exploring the unexplorable tracks '
        area1.description += 'of Amazon is possible. The stories from your forest adventure books '
        area1.description += 'are going to come alive. Yes, you are going to explore the place where Anacondas stay.'
        
        area2 = Area()
        area2.description = 'You cannot think of exploring Amazon other than navigating '
        area2.description += 'through its river, its lifeline. The densest corners of the jungle can only be reached by boat.'
        
        area3 = Area()
        area3.description = 'Entered into a dark cave with absolutely no light inside.'
        
        area4 = Area()
        area4.description = 'The path is very slippery. Please choose a proper shoe to continue climbing.'
        
        area5 = Area()
        area5.description = 'Somehow you managed to make a fire. It is very scary to see '
        area5.description += 'the skeletons of humans inside the cave. It is better to go back to the river.'
        
        area6 = Area()
        area6.description = 'Your selection of shoe is very good for such terrain. '
        
        area7 = DeadlyArea()
        area7.description = 'You have slipped from the mid of the path and you got so many wounds.'
        area7.description += 'Your selection of shoe is not so helpful.'
        
        area8 = Area()
        area8.description = 'You have reached the top of the hill. The sunset scenery makes you feel peace. End of journey.'
        
        area9 = DeadlyArea()
        area9.description = 'You got so many wounds and fractures. You couldn`t make the journey and you have to call SOS! and wait until someone comes and rescue you.'
        
        area10 = DeadlyArea()
        area10.description = 'You got stuck into the deep cave and couldn`t come out. Call SOS! and wait until someone comes to rescue you.'
        
        area1.paths.append(Path('Take a boat : Canoe on the longest river of the World. You need a boat to start your journey', area2))
        
        area2.paths.append(Path('Enter into cave : There is a hidden cave near the waterfall. Climb the rock to reach the caves', area3))
        area2.paths.append(Path('Hike : The waterfall origins from the hill top. Hikes through the dense ridge to climb to the top of the hill', area4))
        
        area3.paths.append(Path('Make a fire : Try to light fire with some stones.', area5))
        
        area4.paths.append(Path('Trial : Trial shoe.', area6))
        area4.paths.append(Path('Hike : Hike shoe.', area7))
        
        area5.paths.append(Path('Continue : Continue exploring into the deep cave.', area10))
        
        area6.paths.append(Path('Continue : Continues to hike the hill.', area8))
        
        area7.paths.append(Path('Heal : Treat your wounds with the medikit that you have carried with you and continue to hike.', area8))
        area7.paths.append(Path('Continue : Continue hiking without any rest', area9))
        
        
        self.currentArea = area1
        
    
    def play(self):
        
        previousArea = None
        
        while(self.player.health > 0):
            
            print()
            
            if(not self.currentArea.damage == 0):
                self.player.health -= self.currentArea.damage
                print('!!!!  You got severe damage and your health will be deducted by {}'.format(self.currentArea.damage))
            
            print('Player Health: ', self.player.health)
            
            print()
            
            print('Area : ', self.currentArea.description)
            
            print()
            
            self.currentArea.printPaths()
            
            print()
            
            choice = input('Choose a Path : ')
            
            print()
            
            path_index = -1
            
            try:
                path_index = int(choice)
            except:
                print('!! Invalid Input !!')
            
            no_of_paths = len(self.currentArea.paths)
            
            if(path_index < 0 or path_index >= (no_of_paths + 1)):
                print('!! Invalid Input !!')
            elif(path_index == no_of_paths):
                
                if(previousArea == None):
                    print('No way to go back !!')
                else:
                    print('Going back')
                    self.currentArea = previousArea
            else:
                previousArea = self.currentArea
                self.currentArea = self.currentArea.paths[path_index].destination
            
            self.player.health -= 5
                
                